#!/bin/bash

RUN_ARCHIVE=`find ${ALL_RUN_ARCHIVES} -maxdepth 2 -name ${DATA_FOLDER} -type d -print -quit 2> /dev/null || true`
if [ -z "$RUN_ARCHIVE" ]; then
	echo "Can't find data folder ${DATA_FOLDER} in [${ALL_RUN_ARCHIVES}]" 1>&2
	exit 1
fi

${JAVA} \
	-Dpicard.useLegacyParser=false ${JavaOptions} \
	-jar ${PICARD} CheckIlluminaDirectory \
	-BASECALLS_DIR ${RUN_ARCHIVE}/Data/Intensities/BaseCalls \
	-READ_STRUCTURE ${READSTRING} \
	-DATA_TYPES BaseCalls \
	-LANES ${LANE} \
	-QUIET true 
