var Xport = function()
{
	var xport = {};
	var debug = 0;
	
	var siteIsValid = false;
	var startNumberIsValid = false;
	var numKitsIsValid = false;

	xport.initPage = function()
	{
		// Step 1
		Events.addEventHandler('step-1', 'wizard-validate', xport.validateStep1);
		Events.addEventHandler('site', 'change', xport.siteOnChange);
		Events.addEventHandler('startNumber', 'blur', xport.startNumberOnChange);
		Events.addEventHandler('startNumber', 'keypress', Events.integerOnly);
		Events.addEventHandler('numKits', 'blur', xport.numKitsOnChange);
		Events.addEventHandler('numKits', 'keypress', Events.integerOnly);
		Events.addEventHandler('viewLogFile', 'click', xport.viewLogFile);
		
		// Navigation
		Buttons.addClickHandler('gorestart', Wizard.restartWizard);
		Buttons.addClickHandler('goregister', Wizard.goRegister);
		Buttons.addClickHandler('gopreview', xport.goPreview);
		Buttons.addClickHandler('viewLogFile2', xport.viewLogFile);
		Buttons.addClickHandler('godownload', xport.downloadBD47File);
		
		Events.addEventHandler('wizard', 'wizard-submit', xport.goExport);

		Doc.show('step-1');
		Wizard.setInputStatus('site', 'invalid');
		Wizard.setInputStatus('startNumber', 'invalid');
		Wizard.setInputStatus('numKits', 'invalid');

		// Load sites
		var frm = document.forms['reggie'];
		var url = '../ReferralGenerator.servlet?ID='+App.getSessionId();
		url += '&cmd=GetSitesAndStartNumber';		
		Doc.addClass('site', 'list-loading');
		frm.site[0] = new Option('loading...');
		Wizard.asyncJsonRequest(url, xport.sitesLoaded);
	}
	
	xport.sitesLoaded = function(response)
	{
		Doc.removeClass('site', 'list-loading');
		var frm = document.forms['reggie'];
		var sites = response.sites;
		frm.site.length = 0;
		frm.site[0] = new Option('- Select site -', '');
		for (var i = 0; i < sites.length; i++)
		{
			var s = sites[i];
			var option = new Option(s.name + ' [' + s.prefix + ']', s.prefix);
			frm.site[frm.site.length] = option;
		}
		frm.site.focus();
		
		frm.startNumber.value = response.lastReferralID || '';
		xport.startNumberOnChange();
		
		frm.numKits.value = response.lastNumKits || '25';
		xport.numKitsOnChange();
		
		if (response.logFile)
		{
			Doc.show('viewLogFile', 'inline');
			Data.set('viewLogFile', 'file-id', response.logFile);
		}
		
		Doc.show('gopreview');
		Doc.show('goregister');
	}
	
	xport.siteOnChange = function()
	{
		var frm = document.forms['reggie'];
		siteIsValid = false;
		Doc.element('sitePrefix').innerHTML = '00 -';
		
		if (frm.site.value == '')
		{
			Wizard.setInputStatus('site', 'invalid', 'Select a site');
			frm.site.focus();
			return;
		}
		
		Doc.element('sitePrefix').innerHTML = frm.site.value+' -';
		siteIsValid = true;
		Wizard.setInputStatus('site', 'valid');
		if (frm.startNumber.value == '') 
		{
			frm.startNumber.focus();
		}
		else
		{
			frm.numKits.focus();
		}
	}
	
	xport.startNumberOnChange = function()
	{
		var frm = document.forms['reggie'];
		startNumberIsValid = false;
		
		var startNumber = frm.startNumber.value;
		if (startNumber == '')
		{
			Wizard.setInputStatus('startNumber', 'invalid', 'Missing');
			return;
		}
		
		if (!startNumber.match(/^\d{5}$/))
		{
			Wizard.setInputStatus('startNumber', 'invalid', 'It must be 5 digits.');
			return;
		}
		
		startNumberIsValid = true;
		Wizard.setInputStatus('startNumber', 'valid');
	}
	
	xport.numKitsOnChange = function()
	{
		var frm = document.forms['reggie'];
		numKitsIsValid = false;
		
		var numKits = frm.numKits.value;
		if (numKits == '')
		{
			Wizard.setInputStatus('numKits', 'invalid', 'Missing');
			return;
		}
		
		if (!numKits.match(/^\d+$/))
		{
			Wizard.setInputStatus('numKits', 'invalid', 'It must be a number.');
			return;
		}
		
		var nk = parseInt(numKits);
		if (nk < 1 || nk > 100)
		{
			Wizard.setInputStatus('numKits', 'invalid', 'It must be between 1 and 100');
			return;
		}
		
		numKitsIsValid = true;
		Wizard.setInputStatus('numKits', 'valid');
	}

	xport.viewLogFile = function(event)
	{
		Dialogs.openPopup('', 'LogFile', 1050, 700);
		Files.viewFile(Data.get(event.currentTarget, 'file-id'), 'LogFile');
	}

	xport.downloadBD47File = function(event)
	{
		var url = App.getRoot()+'filemanager/files/download/-'+App.getSessionId()+'-';
		url += Data.get(event.currentTarget, 'file-path');
		location.href = url;
	}

	xport.validateStep1 = function(event)
	{
		var valid = siteIsValid;
		valid &= startNumberIsValid;
		valid &= numKitsIsValid;
		if (!valid) event.preventDefault();
	}

	xport.goPreview = function()
	{
		if (!Wizard.validateCurrentStep()) return;
		xport.doExport(true);
	}
	
	xport.goExport = function()
	{
		xport.doExport(false);
	}

	xport.doExport = function(preview)
	{
		var frm = document.forms['reggie'];
		var url = '../ReferralGenerator.servlet?ID='+App.getSessionId();
		url += '&cmd=ExportToBD47';

		var submitInfo = {};
		submitInfo.site = frm.site.value;
		submitInfo.kitType = frm.kitType.value;
		submitInfo.startNumber = parseInt(frm.startNumber.value);
		submitInfo.numKits = parseInt(frm.numKits.value);
		
		Doc.hide('previewWrapper');
		if (preview) 
		{
			url += '&preview=1';
			Wizard.asyncJsonRequest(url, xport.onPreviewLoaded, 'POST', JSON.stringify(submitInfo));
		}
		else
		{
			Wizard.asyncJsonRequest(url, xport.submissionResults, 'POST', JSON.stringify(submitInfo));
		}
	}
	
	xport.submissionResults = function(response)
	{
		var msg = response.messages;
		msg[msg.length] = '[HTML]BD47 file save to: <span id="downloadBd47" class="link" title="Download">'+response.bd47Path + '</span>';
		msg[msg.length] = '[HTML]<span id="viewLogFile2" class="link">View log file</span>';
		Wizard.showFinalMessage(msg);
		Data.set('viewLogFile2', 'file-id', response.logFile);
		Data.set('downloadBd47', 'file-path', response.bd47Path);
		Events.addEventHandler('viewLogFile2', 'click', xport.viewLogFile);
		Events.addEventHandler('downloadBd47', 'click', xport.downloadBD47File);
		Doc.show('gorestart');
	}

	
	xport.onPreviewLoaded = function(response)
	{		
		var allLines = response.csv.split('\n');
		var maxLine = allLines.length - 2; // First line is a header line
		
		var html = '<tr><th>'+allLines[0].replace(/;/g, '</th><th>')+'</th></tr>';
		for (var i = 1 ; i <= maxLine; i++)
		{
			html += '<tr><td>'+allLines[i].replace(/;/g, '</td><td>')+'</td></tr>';
		}

		previewList.innerHTML = '<table>'+html+'</table>';
		Doc.show('previewWrapper');
	}

		
	return xport;
}();

Doc.onLoad(Xport.initPage);

