<%@ page
	pageEncoding="UTF-8"
	session="false"
	import="net.sf.basedb.core.User"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.Application"
	import="net.sf.basedb.core.Extract"
	import="net.sf.basedb.core.BioMaterial"
	import="net.sf.basedb.core.MeasuredBioMaterial"
	import="net.sf.basedb.core.BioMaterialEventSource"
	import="net.sf.basedb.core.BioPlate"
	import="net.sf.basedb.core.BioWell"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.query.Restrictions"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.util.formatter.WellCoordinateFormatter"
	import="net.sf.basedb.util.extensions.Extension"
	import="net.sf.basedb.clients.web.Base"	
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="java.util.Arrays"
	import="java.util.Enumeration"
	import="java.util.Collections"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%
final SessionControl sc = Base.getExistingSessionControl(request, "net.sf.basedb.reggie", true);
final String ID = sc.getId();
final String home = ExtensionsControl.getHomeUrl("net.sf.basedb.reggie");
final String root = request.getContextPath();
DbControl dc = null;
try
{
	dc = sc.newDbControl();
	final Extension reggie = ExtensionsControl.get(dc).getExtension("net.sf.basedb.reggie");
	final User user = User.getById(dc, sc.getLoggedInUserId());

	String caseName = Values.getStringOrNull(request.getParameter("caseName"));
	int patientId = Values.getInt(request.getParameter("patientId"));
%>
<base:page id="protocol" type="iframe" favicon="<%=home+"/images/report.png"%>" noskin="true">
<base:head
	scripts="~../reggie-2.js,~retraction_protocol.js" 
	styles="~../css/reggie-2.css,~../css/printable.css"
	>

	<style>
	h1
	{
		margin-top: 1em;
	}
	
	h2
	{
		margin-bottom: 0;
		font-size: 1.2em;
	}
	
	table.protocolheader
	{
		width: 100%;
		border: 1px solid #000000;
		margin-bottom: 1em;
		border-collapse: collapse;
	}
	
	table.protocolheader tr
	{
		vertical-align: middle;
		height: 2.5em;
		max-height: 2.5em;
	}

	table.protocolheader th
	{
		text-align: left;
		font-size: 1em;
		background-color: #F0F0F0;
		padding: 4px;
		border: 1px solid #000000;
	}

	table.protocolheader th.subprompt
	{
		text-align: right;
		font-weight: normal;
	}

	
	table.protocolheader td
	{
		text-align: left;
		font-size: 1em;
		padding: 4px;
		border: 1px solid #000000;
	}
	
	.label
	{
		white-space: nowrap;
	}
	
	.nolabels .label
	{
		display: none;
	}
	
	.colorbox 
	{
		display: inline-block;
		width: 0.85em; 
		height: 0.85em; 
		border: 1px solid #000000;
		margin-left: 0em;
		margin-right: 0.5em;
	}
	
	tr.destroyed
	{
		color: #999999;
		text-decoration: line-through;
	}
	
	</style>
</base:head>
<base:body>
	<div class="paper">
	<form name="reggie" id="wizard">

	<div id="page-data" class="datacontainer"
		data-casename="<%=HTML.encodeTags(caseName)%>"
		data-patient-id="<%=patientId%>"
	></div>
	
	<div id="wizard-status"></div>
	
	<div id="all-protocol" style="display: none;">

	<div id="print-instructions" class="noprint fullwidth">
		<base:button id="print-button" image="<%=home+"/images/print.png"%>" title="Print&hellip;" />
		<span id="printNote">
		<b>Note!</b> 
		For better printing reduce margins to about <i>5mm</i> and set page orientation
		to <i>portrait</i>.
		</span>
		<br clear="all">
	</div>

	<h1>Lab protocol for extract destruction at retracted consent <span class="reggie">Reggie <%=reggie.getAbout().getVersion() %></span></h1>

	<h2>1. Source with retracted consent</h2>
			
	<table class="protocolheader">
		<tr>
			<th style="width: 15%;">Patient</th>
			<td id="patient"></td>
		</tr>
		<tr>
			<th style="width: 15%;">Case(s)</th>
			<td id="allcases"></td>
		</tr>
	</table>

	<h2>2. Samples/extracts to be destroyed</h2>

	<table id="itemTable" class="protocolheader nolabels">
		<thead>
		<tr>
			<th style="width: 10%;">Item type</th>
			<th style="width: 10%;">Name</th>
			<th style="width: 10%;" class="label">Label¹</th>
			<th style="width: 15%;">Storage Box</th>
			<th style="width: 50%;">Storage position</th>
			<th style="width: 15%;">Result/Comment</th>
		</tr>
		</thead>
		<tbody id="itemList"></tbody>
	</table>
	<div id="protocol-footer" style="display: none; margin-bottom: 1em;">
		¹ Some SCAN-B tubes have a non-standard label.
	</div>

	<h2>3. Lab representative certification</h2>
			
	<table class="protocolheader">
		<tr>
			<th style="width: 15%;">Date</th>
			<td style="width: 85%;"></td>
		</tr>
		<tr>
			<th style="width: 15%;">Name</th>
			<td style="width: 85%;"></td>
		</tr>

		<tr>
			<th style="width: 15%;">Signature</th>
			<td style="width: 85%;"></td>
		</tr>

		<tr style="height: 10em; vertical-align: top;">
			<th style="width: 15%;">Comments</th>
			<td style="width: 85%;"></td>
		</tr>
	</table>
			
	</div>
	</form>
	</div>
</base:body>
</base:page>
<%
}
finally
{
	if (dc != null) dc.close();
}
%>